#!/usr/bin/perl
#
$rcsstr='@(#) $Header: /var/cvs/ircgate/ircgate.pl,v 1.3 1997/05/21 23:53:48 dg1kjd Exp $';
# 
# ---------- Copyright / warranty note ----------------------------------------
# This perl script was written "from scratch" by Jens David,
# <dg1kjd@dg1kjd-svr.ampr.org>. It is far from complete, but it serves its
# intended purpose pretty well (I think).
# You may freely use, copy and modify it, as long as you respect the
# following rules:
# - You must not use it to connect any non-amateur-radio irc networks to
#   any amateur-radio convers networks. (This may change in future.)
# - This note may not be removed or changed, but additions may be appended
#   to it at the end.
# - When duplicating this software always duplicate the complete package,
#   i.e. don't remove the documentation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY. The author(s) can't be held reliable for any misfunction or
# misuse of this package.
#
# Please send any suggestions, comments or bug-reports to the email address
# above.
# ---------- End of note ------------------------------------------------------

require 5.002;
use FileHandle;
use Socket;
use Fcntl;

# -----------------------------------------------------------------------------
#                       User configurable parameter section
# -----------------------------------------------------------------------------
#
# My hostname from ircd's point of view
$myhost		= "dg1kjd-gate.ampr.org";
#
# My full name
$myname		= "ircgate\@dg1kjd-svr.ampr.org";
#
# Remote conversd server and port
# Protocol either "AX25" or "IPV4"
#$protconv	= "AX25";
$protconv	= "IPV4";
#$remoteconv	= "DK7WJ-6 via DB0DAR DB0ZDF";
#$remoteconv	= "DB0DAR-8 via DB0DAR";
#$mycall	= "DG1KJD-8";
$remoteconv	= "db0rgb.ampr.org";
$portconv	= 3600;
#
# Remote ircd server and port
$remoteirc	= "dg1kjd-svr";
$portirc	= 6667;
#
# My irc password
$ircpass	= "dg1kjd-gate";
#
# Default convers channel irc users on alphanumeric channels are mapped to
$defchan	= 16384;
#
# We'll ping both the conversd and ircd server in order to measure the rtt
# and to keep the link alive
$pinginterval	= 120;
#
# Set to 1 for debugging output on STDOUT
$debug		= 0;
#
# Short version string
$vshort		= "ircg-0.5";
#
# Long version string
$version	= "ircgate.pl rel. 0.5b";
#
# My name in conversd network
$ircgate	= "ircgate";
#
# Virtual server name substituting all hosts on ircd network
$ircnet		= "ircnet";
#
# -----------------------------------------------------------------------------
#                        End of configuration section
# -----------------------------------------------------------------------------

$crtt = 0;
$clastping = time;
$chisrtt = 0;
$irtt = 0;
$ilastping = time;
$| = 1;

print STDOUT "Link setup (convers)... ";
if ($protconv eq "IPV4") {
	$iaddr   = inet_aton($remoteconv) || die "no host: $remoteconv";
	$caddr   = sockaddr_in($portconv, $iaddr);
	$proto   = getprotobyname("tcp");
	socket(CONVERS, PF_INET, SOCK_STREAM, $proto)  || die "convers socket: $!";
	connect(CONVERS, $caddr) || die "convers connect: $!";
	print(STDOUT "connected.\n");
	fcntl(CONVERS, F_SETFL, fcntl(CONVERS, F_GETFL, 0) | O_NONBLOCK);
} elsif ($protconv eq "AX25") {
	$AF_AX25 = 3;
	$SOCK_SEQPACKET = 5;
	$l=length($caddr);
	socket(CONVERS, $AF_AX25, $SOCK_SEQPACKET, 0) || die "convers socket: $!";
	$caddr = ax25_cr_bindaddr($mycall);
	bind(CONVERS, $caddr);
	$caddr = ax25_cr_sockaddr($remoteconv);
	connect(CONVERS, $caddr) || die "convers connect: $!";
	print(STDOUT "connected.\n");
} else {
	printf STDERR "Error: unknown protocol \"$protconv\".\n";
	exit(1);
}
select(CONVERS); $| = 1;
print CONVERS "/\377\200HOST $ircgate $vshort Admp\n";

$iaddr   = inet_aton($remoteirc) || die "no host: $remoteconv";
$iaddr   = sockaddr_in($portirc, $iaddr);

printf STDOUT "Link setup (irc)... ";
socket(IRC, PF_INET, SOCK_STREAM, $proto)  || die "irc socket: $!";
connect(IRC, $iaddr) || die "irc connect: $!";
print(STDOUT "connected.\n");
fcntl(IRC, F_SETFL, fcntl(IRC, F_GETFL, 0) | O_NONBLOCK);
select(IRC); $| = 1;
select(STDOUT);
print IRC "\r\n";
print IRC "PASS $ircpass\r\n";
print IRC "SERVER $myhost 1 : Convers<->IRC gateway $myname\r\n";

while (1) {
	ctimertt() if (time > ($clastping + $pinginterval));
	itimertt() if (time > ($ilastping + $pinginterval));
	$rin = '';
	vec($rin,fileno(IRC),1) = 1;
	vec($rin,fileno(CONVERS),1) |= 1;
	$ready = select($rout = $rin, undef, undef, 5);
	if ($ready) {
		convread();
		ircread();
	}
}
exit 0;

sub ircread()
{
	my $line;
	while (1) {
		$length = 1;
		if (!defined(recv(IRC, $input, $length, 0))) {
			return if ($! == 11);
			die("ircread():$!");
		}
		return if ($length == 0);
		$char = substr($input, 0, 1);
		$line .= $char unless ($char eq "\r");
		if ($char eq "\n") {
			doirc($line);
			$line = '';
		}
	}
}

sub doirc()
{
	my $line = shift(@_);
	print STDOUT "<IRC:$line" if ($debug);
	if ($line =~ /^\:/) {
		$line =~ /^\:(.+?)\ (.+)/;
		$from = $1;
		$command = $2;
	} else {
		$from = '';
		$command = $line;
	}
switch: {
		if ($command =~ /^SERVER\ (.+?)\ (.+?) \:?(.*)/) {
			$ihost = $1 if (($from eq '') && ($2 == 1));
			last switch;
		}
		if ($command =~ /^PONG\ (.+)/) {
			($pfrom) = split(/\s+/, $1);
			if (($from eq $ihost) && ($pfrom eq $ihost)) {
				$irtt = time - $ilastping;
				$irtt = 1 if ($irtt < 1);
				$desttime = $irtt + $chisrtt;
				print CONVERS "\/\377\200DEST $ircnet $desttime ircd\n";
			}
		}
		if ($command =~ /^NICK\ (.+?)\ (.*)/) {
			$udata{$1} = '@';
			last switch;
		}
		if ($command =~ /^QUIT (.+)/) {
			$reason = $1;
			$reason =~ s/^://;
			$reason = "ircgate: fatal error on socket." if ($reason eq "");
			$utime = time;
			@tchanl = split(/\s+/, $ichanl{$from});
			foreach (@tchanl) {
				print CONVERS "\/\377\200USER $from $ircnet $utime $_ -1 $reason\n";
			}
			last switch;
		}
		if ($command =~ /^USER\ (.+?)\ (.+?)\ (.+?)\ \:(.*)/) {
			$udata{$from} = $4;
			$uhost{$from} = $3;
			$uname{$from} = $1;
			last switch;
		}
		if ($command =~ /^PRIVMSG\ #(.*?) \:(.*)/) {
			$chan = mapchan($1);
			print CONVERS "\/\377\200CMSG $from $chan $2\n";
			last switch;
		}
		if ($command =~ /^PRIVMSG\ (.*?)\:(.*)/) {
			print CONVERS "\/\377\200UMSG $from $1 $2\n";
			last switch;
		}
		if ($command =~ /^JOIN\ .*?\#(.+)/) {
			$uchan = mapchan($1);
			$ichanl{$from} .= "$uchan ";
			$utime = time;
			print CONVERS "\/\377\200USER $from $ircnet $utime -1 $uchan $uname{$from}\@$uhost{$from} - $udata{$from}\n";
			last switch;
		}
		if ($command =~ /^MODE\ \#(.+?)\ (.+)/) {
			$chan = mapchan($1);
			($imode, @oplist) = split(/\s+/, $2);
			$frop = "$ircgate";
			$frop = $from if ($from ne "");
			$cmode = '';
			$cact = '';
			$opcnt = 0;
			$vocnt = 0;
			foreach(split(//, $imode)) {
				$cact = '+' if (/\+/);
				$cact = '-' if (/\-/);
				$cmode .= $cact . 'i' if (/p/);
				$cmode .= $cact . 's' if (/s/);
				$cmode .= $cact . 't' if (/t/);
				$cmode .= $cact . 'm' if (/m/);
				$opcnt++ if (/o/);
				last if (/\ /);
			}
			print CONVERS "\/\377\200MODE $chan $cmode\n" if ($cmode ne '');
			if ($opcnt) {
				for ($i = 0; $i < $opcnt; $i++) {
					print CONVERS "\/\377\200OPER $frop $chan @oplist[$i]\n";
				}
			}
			last switch;
		}
		if ($command =~ /^PART\ \#(.+)/) {
			$uchan = mapchan($1);
			$utime = time;
			print CONVERS "\/\377\200USER $from $ircnet $utime $uchan -1 leaving\n";
			print CONVERS "\/\377\200USER $from $ircnet $utime $uchan -1 leaving\n";
			last switch;
		}
		if ($command =~ /^AWAY\ ?\:?(.*)/) {
			$utime = time;
			print CONVERS "\/\377\200AWAY $from $ircnet $utime $1\n";
			last switch;
		}
		if ($command =~ /^INVITE\ (.+?)\ \:?\#?(.*)/) {
			$uchan = mapchan($2);
			print CONVERS "\/\377\200INVI $from $1 $uchan\n";
			last switch;
		}
		if ($command =~ /^TOPIC\ \#(.+?)\ \:?(.*)/) {
			$utime = time;
			$iutopic = $2;
			$chan = mapchan($1);
			$iutopic = "" if ($iutopic =~ /^\@/);
			print CONVERS "\/\377\200TOPI $from $ircnet $utime $chan $iutopic\n";
			last switch;
		}
	}
}

sub convread()
{
	my $line;
	while (1) {
		$length = 1;
		if (!defined(recv(CONVERS, $input, $length, 0))) {
			return if ($! == 11);
			die("convread():$!");
		}
		return if ($length == 0);
		$char = substr($input, 0, 1);
		$line .= $char unless ($char eq "\r");
		if ($char eq "\n") {
			doconv($line);
			$line = '';
		}
	}
}

sub ctimertt()
{
	$clastping = time;
	print CONVERS "\/\377\200PING\n";
}

sub itimertt()
{
	$ilastping = time;
	print IRC "PING $ihost\r\n";

}

sub doconv()
{
	my $line = shift(@_);
	print STDOUT "<CNV:$line" if ($debug);
	return if (!($line =~ /^\/\377\200(.{4})\s*(.*)/));
	$command = uc($1);
	$paramstr = $2;
switch:	{
		if ($command eq "HOST") {
			dochost($paramstr);
			last switch;
		}
		if ($command eq "ROUT") {
			docrout($paramstr);
			last switch;
		}
		if ($command eq "AWAY") {
			docaway($paramstr);
			last switch;
		}
		if ($command eq "INVI") {
			docinvi($paramstr);
			last switch;
		}
		if ($command eq "USER") {
			docuser($paramstr);
			last switch;
		}
		if ($command eq "CMSG") {
			doccmsg($paramstr);
			last switch;
		}
		if ($command eq "UMSG") {
			documsg($paramstr);
			last switch;
		}
		if ($command eq "TOPI") {
			doctopi($paramstr);
			last switch;
		}
		if ($command eq "MODE") {
			docmode($paramstr);
			last switch;
		}
		if ($command eq "PING") {
			docping($paramstr);
			last switch;
		}
		if ($command eq "PONG") {
			docpong($paramstr);
			last switch;
		}
	}
}

sub dochost()
{
	my $arg = shift(@_);
	($chost, $csoft, $cfac) = split(/\s+/, $arg);
	print IRC ": $myhost SERVER $chost.nodomain.org 2 :$csoft conversd server gated via $myname [$cfac]\r\n";	
}

sub docrout()
{
	my $arg = shift(@_);
	($cdest, $cuser, $cttl) = split(/\s+/, $arg);
	print CONVERS "\/\377\200UMSG conversd $cuser *** route: $ircgate ($cttl) $ircnet -> $ircnet\n";
	print CONVERS "\/\377\200UMSG conversd $cuser *** $ircgate: This an experimental gateway between convers and irc network.\n";
	print CONVERS "\/\377\200UMSG conversd $cuser *** $ircgate: The virtual host \"$ircnet\" substitutes the rest of the irc network.\n";
	print CONVERS "\/\377\200UMSG conversd $cuser *** $ircgate: At the current implementation level no routing trace across this\n";
	print CONVERS "\/\377\200UMSG conversd $cuser *** $ircgate: gateway is possible, sorry.\n";
	print CONVERS "\/\377\200UMSG conversd $cuser *** $ircgate: Please send questions, comments and suggestions to:\n";
	print CONVERS "\/\377\200UMSG conversd $cuser *** $ircgate: dg1kjd\@dg1kjd-svr.ampr.org / dg1kjd\@db0lj.\#rpl.deu.eu .\n";
	print CONVERS "\/\377\200UMSG conversd $cuser *** $ircgate: This is $version .\n";
	print CONVERS "\/\377\200UMSG conversd $cuser *** $ircgate: $rcsstr\n";
}

sub docmode()
{
	my $arg = shift(@_);
	$citmode = '';
	($cichan, $cimode) = split(/\s+/, $arg);
	foreach(split(//, $cimode)) {
		$citmode .= '+' if (/\+/);
		$citmode .= '-' if (/\-/);
		$citmode .= 'p' if (/i/);
		$citmode .= 's' if (/s/);
		$citmode .= 't' if (/t/);
		$citmode .= 'm' if (/m/);
	}
	print IRC ":$myhost MODE \#$cichan $citmode\r\n";
}

sub docuser()
{
	my $arg = shift(@_);
	($cinick, $cihost, $citime, $cifromch, $citoch, @ciudata) = split(/\s+/, $arg);
	@ciudata = ('no personal info') if (@ciudata == 0);
	if ($citoch == -1) {
		print IRC ":$cinick PART \#$cifromch\r\n";
		$chancnt{$cinick}--;
	}
	if ($cifromch == -1) {
		if ($chancnt{$cinick} == 0) {
			print IRC "NICK $cinick\r\n";
			print IRC ":$cinick USER $cinick conversnet $cihost :@ciudata\r\n";
		}
		print IRC ":$cinick JOIN \#$citoch\r\n";
		$chancnt{$cinick}++;
	}
	print IRC ":$cinick QUIT\r\n" if ($chancnt{$cinick} == 0);
}

sub doctopi()
{
	my $arg = shift(@_);
	($cinick, $cihost, $citime, $cichan, @citopic) = split(/\s+/, $arg);
	print IRC ":$cinick TOPIC #$cichan :@citopic\r\n" unless ($cinick eq 'conversd');
}

sub doccmsg()
{
	my $arg = shift(@_);
	($cinick, $cichan, @citext) = split(/\s+/, $arg);
	print IRC ":$cinick PRIVMSG #$cichan :@citext\r\n";
}

sub documsg()
{
	my $arg = shift(@_);
	($cifrom, $cito, @citext) = split(/\s+/, $arg);
	print IRC ":$cifrom PRIVMSG $cito :@citext\r\n";
}

sub docping()
{
	my $arg = shift(@_);
	print CONVERS "\/\377\200PONG $crtt\n";
}

sub docpong()
{
	my $arg = shift(@_);
	$crtt = time-$clastping;
	$crtt = 1 if ($crtt < 1);
	$chisrtt = $arg+0;
	$chisrtt = 1 if ($chisrtt < 1);
}

sub docaway()
{
	my $arg = shift(@_);
	($ciuser, $cihost, $citime, @ciatext) = split(/\s+/, $arg);
	print IRC ":$ciuser AWAY :@ciatext\r\n";
}

sub docinvi()
{
	my $arg = shift(@_);
	($cifrom, $cito, $cichan) = split(/\s+/, $arg);
	print IRC ":$cifrom INVITE $cito :\#$cichan\r\n";
}

sub mapchan()
{
	my $arg = shift(@_);
	$arg =~ s/\://g;
	return $arg if (($arg =~ /^[0-9]+$/) && ($arg > 1) && ($arg < 32768));
	return $defchan;
}

# ---------------------------------------------------------------------------
# AX.25
# ---------------------------------------------------------------------------

sub ax25_shift_addr {
	my($call_asc) = @_;
	my $call; my $l; my $ssid; my $calla; my $callb; my $callc; my $calld; my $calle; my $callf; my $ssida;

	if ($call_asc =~ /^(\w+)-(\d+)$/) {	# DG1ABC-2
		$call = $1;
		$call = uc($call);
		$l = length($call);
		$call .= " " x (6-$l);
		$ssid = $2;
	} else {				# DG1ABC
		$call = $_;
		$call = uc($call);
		$l = length($call);
		$call .= " " x (6-$l);
		$ssid = 0;
	}
	($calla, $callb, $callc, $calld, $calle, $callf) = unpack("CCCCCC", $call);
	$calla <<= 1;
	$callb <<= 1;
	$callc <<= 1;
	$calld <<= 1;
	$calle <<= 1;
	$callf <<= 1;
	$ssida = $ssid<<1;
	$addr = pack("CCCCCCC", $calla, $callb, $callc, $calld, $calle, $callf, $ssida);
	return $addr;
}

sub ax25_cr_sockaddr {
	my $saddr; my $addr; my $n;
	my($pathdest) = @_;

	$n=0;
	$digi = "";
	foreach (split(/\s+/, $pathdest)) {
		next if (/^v$/ || /^V$/ || /^via$/ || /^VIA$/);
		$addr = ax25_shift_addr($_);
		if ($n == 0) {
			$dest = $addr;
		} else {
			$digi .= $addr;
		}
		$n++;
	}
	for ($i=$n; $i<=8; $i++) {
		$digi .= pack("CCCCCCC", 0, 0, 0, 0, 0, 0, 0);
	}
	$saddr = pack("S", $AF_AX25);
	$saddr .= $dest;
	$saddr .= pack("CCC", 0, 0, 0);
	$saddr .= pack("i", $n-1);
	$saddr .= $digi;
	return $saddr;
}

sub ax25_cr_bindaddr {
	my($mycall)= @_;
	my $l;

	$saddr = pack("S", $AF_AX25) . ax25_shift_addr($mycall);
	$saddr .= pack("C" x 63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
	$l = length($saddr);
	return $saddr;
}

sub print_sockaddr {
	my($saddr) = @_;

	($pa, $pb, $pc, $pd, $pe, $pf, $pg, $ph, $pi, $pj, $pl, $pm, $pn, $po, $pp, $pq, $pr, $ps, $pt, $pu, $pv, $pw, $px, $py, $pz) = unpack("CCCCCCCCCCCCCCCCCCCCCCCCCC", $saddr);
	print(STDOUT "saddr: len=$l $pa $pb $pc $pd $pe $pf $pg $ph $pi $pj $pk $pl $pm $pn $po $pp $pq $pr $ps $pt $pu $pv $pw $px $py $pz\n");
}
